package unitTest;

import static org.junit.jupiter.api.Assertions.assertFalse;
import static org.junit.jupiter.api.Assertions.assertTrue;

import java.util.ArrayList;
import java.util.Collection;

import org.junit.jupiter.api.BeforeEach;
import org.junit.jupiter.api.DynamicTest;
import org.junit.jupiter.api.TestFactory;
import org.junit.jupiter.api.function.Executable;

import exceptions.ImageInvalidException;
import project.Auction;
import project.Category;
import project.Item;
import project.ItemPicture;
import project.User;

public class ItemPictureUnitTest {

	@BeforeEach
	public void reset() {

		Item.items = new ArrayList<Item>();
		User.users = new ArrayList<User>();
		Auction.auctions = new ArrayList<Auction>();
		Category.categories = new ArrayList<Category>();

	}

	@TestFactory
	public Collection<DynamicTest> addPictureAcceptanceTest() throws ImageInvalidException {

		Item i = Item.getInstance();
		ArrayList<ItemPicture> rightList = new ArrayList<ItemPicture>();

		for (int x = 0; x < 10; x++) {
			rightList.add(new ItemPicture(x));
		}

		i.addPicture(rightList);

		ArrayList<ItemPicture> wrongList = new ArrayList<ItemPicture>();
		for (int x = 10; x < 20; x++) {
			wrongList.add(new ItemPicture(x));
		}

		Collection<DynamicTest> dynamicTests = new ArrayList<DynamicTest>();

		for (int e = 0; e < rightList.size(); e++) {
			ItemPicture toRemove = rightList.get(e);
			Executable exec = () -> assertTrue(ItemPicture.remove(toRemove.getId(), i));
			DynamicTest dTest = DynamicTest.dynamicTest("Existing images", exec);

			dynamicTests.add(dTest);
		}

		for (int e = 0; e < wrongList.size(); e++) {
			ItemPicture toRemove = wrongList.get(e);
			Executable exec = () -> assertFalse(ItemPicture.remove(toRemove.getId(), i));
			DynamicTest dTest = DynamicTest.dynamicTest("Not existen images", exec);

			dynamicTests.add(dTest);
		}

		return dynamicTests;
	}
}
